open Flight;;

let n = 4;;

let a = Array.create  n 1.0
and b = Array.create n 2.0;;

let oneD_to_twoD i = (i mod n, i / n);;
let twoD_to_oneD (x,y) = x + (y * n);;


let (my_x,my_y) = oneD_to_twoD (local);;

let rec broadcast ydir x = 
  sync (
    if ydir then 
      if my_y - 1 < 0 then x
      else get (broadcast true x) from (twoD_to_oneD (my_x,my_y - 1))
   else
      if my_x - 1 < 0 then x
      else get (broadcast false x) from (twoD_to_oneD (my_x - 1,my_y)) 
  )
;;

let rec scalar_prod_aux vec1 vec2 i =
      if i = Array.length vec1 then 0.0
      else (vec1.(i) *. vec2.(i)) +. scalar_prod_aux vec1 vec2 (i+1)
;;

let scalar_prod vec1 vec2 =
  scalar_prod_aux vec1 vec2 0;;

let v = scalar_prod (broadcast false a) (broadcast true b)
in
  Printf.printf "Processus %d: %f\n" local v;;


close_Flight();;
