(***********************************************************************)
(*                                                                     *)
(*      lancement du serveur , nocf  proto en  Camlp4                  *)
(*                                                                     *)
(*     Baia, Garigou : TER maitrise Paris 6 printemps 2001             *)
(*     modifie par                                                     *)
(*       Emmanuel Chailloux, Equipe PPS, universite P7, projet CARAML  *)
(*                                                                     *)
(*     $Id: start.ml,v 1.3 2003/06/01 20:48:03 emmanuel Exp $          *)
(*                                                                     *)
(***********************************************************************)

let send_addrs nodes i p = 
  let (ic,oc) = ThreadUnix.open_connection (Unix.ADDR_INET(i,p)) 
  in
    output_string oc ((Marshal.to_string (nodes, 0, 0) [])^"\n");
    flush oc;
    Unix.shutdown_connection ic;;


let main () = 
  try 
    let port = int_of_string Sys.argv.(1) in 
    let nodes = (Array.length Sys.argv) - 2 in 

    (* tableau contenant les adresses IP de tous les processus *)
    let addrs = 
      Array.init nodes 
       (fun i -> (Unix.gethostbyname (Sys.argv.(i+2))).Unix.h_addr_list.(0))
    in 
      for i = 0 to (nodes - 1) do
        send_addrs nodes addrs.(i) (port+i)
      done;
      print_string "Sortie normale\n"; print_newline()
  with _ ->       print_string "Sortie exceptionnelle\n"; print_newline();;


main();;

