(***********************************************************************)
(*                                                                     *)
(*      utils:  fonctions utilitaire com/serv                          *)
(*                                                                     *)
(*      nocf  proto en  Camlp4                                          *)
(*                                                                     *)
(*       Emmanuel Chailloux, Equipe PPS, universite P7, projet CARAML  *)
(*                                                                     *)
(*     $Id: utils.ml,v 1.1 2003/06/01 20:48:03 emmanuel Exp $         *)
(*                                                                     *)
(***********************************************************************)

let debug = ref true;;

(* lecture d'une ligne *)
let my_input_line fd =
  let s = " " and r = ref ""
  in
    while (ThreadUnix.read fd s 0 1 > 0) && s.[0] <> '\n' do
      r := !r ^ s
    done;
    !r;;

(* calcule sa propre adresse *)
let get_my_addr () =
   (Unix.gethostbyname(Unix.gethostname())).Unix.h_addr_list.(0) ;;      

(* attente de connexions *)
let wait_connection fun_service sock =
    while (true) do
      if !debug then (Printf.printf ("Avant accept\n"); flush stdout);
      let (s_descr,s_addr) = ThreadUnix.accept sock
      in
        if !debug then (Printf.printf "Utils: wait_connection\n"; flush stdout);     
        ignore(Thread.create (fun_service s_descr) s_addr);
    done;;

(* lancement d'un serveur  *)
let start_server fun_service addr port nlisten =
  if !debug then (Printf.printf "Utils: starting start_server\n"; flush stdout);
  let sock = ThreadUnix.socket Unix.PF_INET Unix.SOCK_STREAM 0
  in
    Unix.bind sock (Unix.ADDR_INET(addr,port));
    Unix.listen sock nlisten;
    Thread.create (wait_connection fun_service) sock;;

